ompi/class/ompi_circular_buffer_fifo.h File Reference.TH "ompi/class/ompi_circular_buffer_fifo.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/class/ompi_circular_buffer_fifo.h \- This defines a set of functions to create, and manipulate a FIFO set up in a circular buffer. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi/include/constants.h'\fP
.br
\fC#include 'opal/include/sys/cache.h'\fP
.br
\fC#include 'opal/include/sys/atomic.h'\fP
.br
\fC#include 'ompi/mca/mpool/mpool.h'\fP
.br
\fC#include 'opal/util/pow2.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOMPI_CB_ERROR\fP   -1"
.br
.ti -1c
.RI "#define \fBOMPI_CB_FREE\fP   (void *)-2"
.br
.ti -1c
.RI "#define \fBOMPI_CB_RESERVED\fP   (void *)-3"
.br
.ti -1c
.RI "#define \fBOMPI_CB_NULL\fP   (void *)-4"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef ompi_cb_fifo_ctl_t \fBompi_cb_fifo_ctl_t\fP"
.br
.ti -1c
.RI "typedef ompi_cb_fifo_t \fBompi_cb_fifo_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "static void * \fBompi_cb_fifo_read_from_tail\fP (ompi_cb_fifo_t *fifo, bool flush_entries_read, bool *queue_empty, ssize_t offset)"
.br
.RI "\fITry to read pointer from the tail of the queue. \fP"
.ti -1c
.RI "static int \fBompi_cb_fifo_size\fP (ompi_cb_fifo_t *fifo)"
.br
.RI "\fIReturn the fifo size. \fP"
.ti -1c
.RI "static int \fBompi_cb_fifo_init_same_base_addr\fP (int size_of_fifo, int lazy_free_freq, int fifo_memory_locality_index, int head_memory_locality_index, int tail_memory_locality_index, ompi_cb_fifo_t *fifo, \fBmca_mpool_base_module_t\fP *memory_allocator)"
.br
.RI "\fIInitialize a fifo. \fP"
.ti -1c
.RI "static int \fBompi_cb_fifo_free_same_base_addr\fP (ompi_cb_fifo_t *fifo, \fBmca_mpool_base_module_t\fP *memory_allocator)"
.br
.RI "\fIfunction to cleanup the fifo \fP"
.ti -1c
.RI "static int \fBompi_cb_fifo_write_to_slot_same_base_addr\fP (int slot, void *data, ompi_cb_fifo_t *fifo)"
.br
.RI "\fIWrite pointer to the specified slot. \fP"
.ti -1c
.RI "static int \fBompi_cb_fifo_write_to_head_same_base_addr\fP (void *data, ompi_cb_fifo_t *fifo)"
.br
.RI "\fITry to write pointer to the head of the queue. \fP"
.ti -1c
.RI "static int \fBompi_cb_fifo_get_slot_same_base_addr\fP (ompi_cb_fifo_t *fifo)"
.br
.RI "\fIReserve slot in the fifo array. \fP"
.ti -1c
.RI "static void * \fBompi_cb_fifo_read_from_tail_same_base_addr\fP (ompi_cb_fifo_t *fifo, bool flush_entries_read, bool *queue_empty)"
.br
.RI "\fITry to read pointer from the tail of the queue. \fP"
.in -1c
.SH "Detailed Description"
.PP 
This defines a set of functions to create, and manipulate a FIFO set up in a circular buffer. 

FIFO elements are assumed to be pointers. Pointers are written to the head, and read from the tail. For thread safety, a spin lock is provided in the ompi_cb_fifo_ctl_t structure, but it's use must be managed by the calling routines - this is not by these set of routines. Queues are addressed relative to an offset from the base of a memory pool, in this way, different processes with different base addresses can access these queue at the same time.
.SH "Function Documentation"
.PP 
.SS "static int ompi_cb_fifo_free_same_base_addr (ompi_cb_fifo_t * fifo, \fBmca_mpool_base_module_t\fP * memory_allocator)\fC [inline, static]\fP"
.PP
function to cleanup the fifo 
.PP
\fBParameters:\fP
.RS 4
\fIfifo\fP Pointer to data structure defining this fifo (IN)
.br
\fImemory_allocator\fP Pointer to the memory allocator to use to allocate memory for this fifo. (IN) 
.RE
.PP

.SS "static int ompi_cb_fifo_get_slot_same_base_addr (ompi_cb_fifo_t * fifo)\fC [inline, static]\fP"
.PP
Reserve slot in the fifo array. 
.PP
\fBParameters:\fP
.RS 4
\fIfifo\fP Pointer to data structure defining this fifo (IN)
.RE
.PP
Slot index to which data is written
.PP
OMPI_CB_ERROR failed to allocate index 
.SS "static int ompi_cb_fifo_init_same_base_addr (int size_of_fifo, int lazy_free_freq, int fifo_memory_locality_index, int head_memory_locality_index, int tail_memory_locality_index, ompi_cb_fifo_t * fifo, \fBmca_mpool_base_module_t\fP * memory_allocator)\fC [inline, static]\fP"
.PP
Initialize a fifo. 
.PP
\fBParameters:\fP
.RS 4
\fIsize_of_fifo\fP Length of fifo array (IN)
.br
\fIfifo_memory_locality_index\fP Locality index to apply to the fifo array. Not currently in use (IN)
.br
\fItail_memory_locality_index\fP Locality index to apply to the head control structure. Not currently in use (IN)
.br
\fItail_memory_locality_index\fP Locality index to apply to the tail control structure. Not currently in use (IN)
.br
\fIfifo\fP Pointer to data structure defining this fifo (IN)
.br
\fImemory_allocator\fP Pointer to the memory allocator to use to allocate memory for this fifo. (IN)
.RE
.PP
Error code 
.SS "static void* ompi_cb_fifo_read_from_tail (ompi_cb_fifo_t * fifo, bool flush_entries_read, bool * queue_empty, ssize_t offset)\fC [inline, static]\fP"
.PP
Try to read pointer from the tail of the queue. 
.PP
\fBParameters:\fP
.RS 4
\fIdata\fP Pointer to where data was be written (OUT)
.br
\fIfifo\fP Pointer to data structure defining this fifo (IN)
.br
\fIflush_entries_read\fP force the lazy free to happen (IN)
.br
\fIqueue_empty\fP checks to see if the fifo is empty, but only if flush_entries_read is set (OUT)
.RE
.PP
Slot index to which data is written 
.SS "static void* ompi_cb_fifo_read_from_tail_same_base_addr (ompi_cb_fifo_t * fifo, bool flush_entries_read, bool * queue_empty)\fC [inline, static]\fP"
.PP
Try to read pointer from the tail of the queue. 
.PP
\fBParameters:\fP
.RS 4
\fIdata\fP Pointer to where data was be written (OUT)
.br
\fIfifo\fP Pointer to data structure defining this fifo (IN)
.br
\fIflush_entries_read\fP force the lazy free to happen (IN)
.br
\fIqueue_empty\fP checks to see if the fifo is empty, but only if flush_entries_read is set (OUT)
.RE
.PP
Slot index to which data is written 
.SS "static int ompi_cb_fifo_size (ompi_cb_fifo_t * fifo)\fC [inline, static]\fP"
.PP
Return the fifo size. 
.PP
\fBParameters:\fP
.RS 4
\fIfifo\fP Pointer to data structure defining this fifo (IN)
.RE
.PP
fifo size 
.SS "static int ompi_cb_fifo_write_to_head_same_base_addr (void * data, ompi_cb_fifo_t * fifo)\fC [inline, static]\fP"
.PP
Try to write pointer to the head of the queue. 
.PP
\fBParameters:\fP
.RS 4
\fIdata\fP Pointer value to write in specified slot (IN)
.br
\fIfifo\fP Pointer to data structure defining this fifo (IN)
.RE
.PP
Slot index to which data is written 
.SS "static int ompi_cb_fifo_write_to_slot_same_base_addr (int slot, void * data, ompi_cb_fifo_t * fifo)\fC [inline, static]\fP"
.PP
Write pointer to the specified slot. 
.PP
\fBParameters:\fP
.RS 4
\fIslot\fP Slot index (IN)
.br
\fIdata\fP Pointer value to write in specified slot (IN)
.br
\fIfifo\fP Pointer to data structure defining this fifo (IN)
.RE
.PP
Slot index to which data is written 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
